package dev.kske.chess.event;

import java.util.EventObject;

import dev.kske.chess.Board;
import dev.kske.chess.piece.Piece.Color;

/**
 * Project: <strong>Chess</strong><br>
 * File: <strong>GameEvent.java</strong><br>
 * Created: <strong>03.07.2019</strong><br>
 * Author: <strong>Kai S. K. Engelbart</strong>
 */
public class GameEvent extends EventObject {

	private static final long serialVersionUID = -6783035746521826589L;

	private final Board			source;
	private final GameEventType	eventType;
	private final Color			color;

	public GameEvent(Board source, GameEventType eventType, Color color) {
		super(source);
		this.source		= source;
		this.eventType	= eventType;
		this.color		= color;
	}

	public Board getSource() { return source; }

	public GameEventType getEventType() { return eventType; }

	public Color getColor() { return color; }

	public static enum GameEventType {
		CHECK, CHECKMATE, STALEMENT, NONE;
	}
}
